#!/usr/bin/python
import sys
import pympgedit as mpgedit
import time

class MyPlay:
    def __init__(self, mp3file):
        self.mp3file = mp3file
        self.mpctx = None
        self.count = 0
                 
    def status(self, sec, msec):
        self.count += 1
        sys.stdout.write('Frame %5d: %02d.%03d sec\r' % (self.count, sec, msec))
        sys.stdout.flush();            
        return 1        

    def stop(self):
        self.mpctx.stop()

    def play(self):                           
        print 'Playing', self.mp3file
        mpgedit.Index(self.mp3file).index()
        self.mpctx = mpgedit.Play(self.mp3file)  
        time = self.mpctx.total_time()
        print 'Total: size=%d time=%d.%03d' % (self.mpctx.total_size(), time[0], time[1])
        print 'Previous volume: left=%d right=%d' % self.mpctx.get_volume()        
        self.mpctx.set_volume(25, 25)
        print 'New volume: left=%d right=%d' % self.mpctx.get_volume()        
        self.mpctx.play(self.status) 

    def get_total_time(self):
        return self.mpctx.total_time()

try:
    p = MyPlay(sys.argv[1])
    p.play()
    time.sleep(p.get_total_time()[0] + 5)
    print
except KeyboardInterrupt:
    try:
        p.stop()
    except KeyboardInterrupt:
        print "p.stop was received KeyboardInterrupt"
